<?php
namespace Util;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DependencyInjection\InstanceManager;
use Util\Instance\Service as InstanceService;
use Util\Instance\Repository as InstanceRepository;
use Util\Instance\Factory as InstanceFactory;

class InstanceProvider {
    
    public static function getService()
    {
        return InstanceService::getInstance();
    }
    
    public static function getRepository()
    {
        return InstanceRepository::getInstance();
    }
    
    public static function getFactory()
    {
        return InstanceFactory::getInstance();
    }

    /** @return \Util\Utilities */
    public static function getUtilities()
    {
        return InstanceManager::getInstance()->getService('\Util\Utilities');
    }
    
    public static function getEntityManager()
    {
        return InstanceManager::getInstance()->getService('entityManager');
    }

    /** @return \Teknisa\Libs\Util\Environment */
    public static function getEnvironment()
    {
        return InstanceManager::getInstance()->getService('libEnvironment');
    }

    /** @return \Zeedhi\Framework\Session\Session */
    public static function getSession()
    {
        return InstanceManager::getInstance()->getService('session');
    }

    /** @return  \Util\Mail\ProductDeployMail */
    public static function getMailProductDeployMail()
    {
        return InstanceManager::getInstance()->getService('\Util\Mail\ProductDeployMail');
    }

    /** @return  \Zeedhi\DevOps\Util\Environment */
    public static function getDevOpsEnvironment()
    {
        return InstanceManager::getInstance()->getService('devOpsEnvironment');
    }

    /** @return \Zeedhi\Framework\DB\Mongo\Mongo */
    public static function getLicenseMongoDB()
    {
        return InstanceManager::getInstance()->getService('licenseMongoDB');
    }

    /** @return \Zeedhi\Zmart\QueryBuilders\Mongo\QueryBuilder */
    public static function getMongoQueryBuilder()
    {
        return InstanceManager::getInstance()->getService('mongoQueryBuilder');
    }
}