import { Http } from '@zeedhi/core';
import { DashboardController } from './DashboardController';

export class AppController {
  public async updateGraphicForFourMonth({ component }: any) {
    const uri = '/callGraphicForFourMonth';
    const request = await Http.get(uri);
    const values = [request.data.dataset.callGraphicForFourMonth];
    const meses = [];
    const aberto = [];
    const emProcesso = [];
    const aguardando = [];
    const fechado = [];
    if (values.length > 0) {
      for (let i = 0; i < values[0].length; i += 1) {
        meses.push(values[0][i].MES);
        aberto.push(values[0][i].OPENED);
        emProcesso.push(values[0][i].INPROGRESS);
        aguardando.push(values[0][i].WAITING);
        fechado.push(values[0][i].CLOSED);
      }
    }
    const options = {
      series: [
        {
          name: 'Em aberto',
          data: aberto,
        },
        {
          name: 'Fechado',
          data: fechado,
        },
        {
          name: 'Em processo',
          data: emProcesso,
        },
        {
          name: 'Aguardando ação do cliente',
          data: aguardando,
        },
      ],
      xaxis: {
          categories: meses,
      },
    };
    component.updateChart(options);
  }

  public async countCallsByTypePieChart({ component }: any) {
    const dashController = new DashboardController();
    const uri = '/countCallsByType';
    const request = await Http.get(uri);
    const values = [request.data.dataset.countCallsByType];
    const tipo = [];
    const quantidade = [];
    if (values.length > 0) {
      for (let i = 0; i < values[0].length; i += 1) {
        tipo.push(values[0][i].TYPE);
        quantidade.push(Number(values[0][i].QUANTITY));
      }
    }
    const newTipo = [];
    if (tipo.length > 0) {
      for (let i = 0; i < tipo.length; i += 1) {
        if (tipo[i] === 'I') {
          newTipo.push('Produto (Zeedhi: App, Browser, Mobile)');
        } else {
          newTipo.push('Produto (Delphi: Windows)');
        }
      }
    }
    const options = {
      labels: newTipo,
      series: quantidade,
      chart: {
        id: 'pie-chart',
        height: '100%',
        toolbar: {
          show: true,
        },
        events: {
          dataPointSelection: dashController.typeChartClick,
        },
      },
    };
    component.updateChart(options);
  }

  public async countCallsByLabelPieChart({ component }: any) {
    const dashController = new DashboardController();
    const uri = '/countCallsByLabel';
    const request = await Http.get(uri);
    const values = [request.data.dataset.countCallsByLabel];
    const label = [];
    const quantidade = [];
    if (values.length > 0) {
      for (let i = 0; i < values[0].length; i += 1) {
        label.push(values[0][i].LABEL);
        quantidade.push(Number(values[0][i].QUANTITY));
      }
    }
    const options = {
      labels: label,
      series: quantidade,
      chart: {
        id: 'pie-chart',
        height: '100%',
        toolbar: {
          show: true,
        },
        events: {
          dataPointSelection: dashController.labelChartClick,
        },
      },
    };
    component.updateChart(options);
  }
}
