import { Metadata, Http } from '@zeedhi/core';
import { ITabsBeforeChangeEventParam, Form, Modal, ModalService } from '@zeedhi/common';
// import { TekGrid } from '@zeedhi/teknisa-components-vuetify';
import { DialogServiceCustom } from '@/services/DialogServiceCustom';
import { IterableComponentRender } from '@zeedhi/teknisa-components-common';
// import { FileUpload } from '@/services/FileUpload';

export class DemandManagementController {
	public baseUrl = '';

	public callDescription = '';

	public callType = '';

	public callRelationship = '';

	public showDemandManagementForm = false;

    get isVisibleDemandManagementGrid() {
		return !this.showDemandManagementForm;
    }

	private modalUploadFile!: Modal;

	public onMountedGeneralCard() {
		this.baseUrl = process.env.VUE_APP_END_POINT;
		console.log(this.baseUrl);
	}

	public rowClickGridDemandManagement(params: any) {
		this.showDemandManagementForm = true;
		this.callDescription = params.row.REFERENCE;
		this.callType = params.row.TYPE;
		this.callRelationship = params.row.CALL_RELATIONSHIP;
		this.fillCallForm();
		// const callFormInstance = Metadata.getInstance<Form>('formDemandManagement');
		// console.log(callFormInstance);
	}

	public fillCallForm() {
		// console.log(params);
		const callFormInstance = Metadata.getInstance<Form>('formDemandManagement');
		console.log(callFormInstance);
		const sendObject = { params: {
				CALL_RELATIONSHIP: this.callRelationship,
				CALL_TYPE: this.callType,
			},
		};
		const callData = Http.get('call', sendObject);
		console.log(callData);
	}

	public clickBackCardFormDemandManagement() {
		const tabsInstance = Metadata.getInstance<ITabsBeforeChangeEventParam>('tabMainFormDemandManagement');
		tabsInstance.activeTab = 0;
		this.showDemandManagementForm = false;
	}

	public onCreatedIterableComments(params: any) {
		if (params.component.activeTab === 1) {
			setTimeout(async () => {
				const iterableComments = Metadata.getInstance<IterableComponentRender>('iterableComments');
				iterableComments.datasource.filter.CALL_TYPE = this.callType;
				iterableComments.datasource.filter.CALL_RELATIONSHIP = this.callRelationship;
				try {
					await iterableComments.datasource.get();
				} catch (e) {
					DialogServiceCustom.showErrorBackend(e);
				}
			}, 1);
		}

		if (params.component.activeTab === 2) {
			setTimeout(async () => {
				const gridAttachments = Metadata.getInstance<any>('gridAttachments');
				console.log(gridAttachments);
				gridAttachments.datasource.filter.CALL_TYPE = this.callType;
				gridAttachments.datasource.filter.CALL_RELATIONSHIP = this.callRelationship;
				try {
					await gridAttachments.datasource.get();
				} catch (e) {
					DialogServiceCustom.showErrorBackend(e);
				}
			}, 1);
		}
	}

	public clickIterableComments(params: any) {
		console.log(params);
	}

	public onMountedCollapseCardComments(params: any) {
		params.component.readonly = params.component.readonly === 'true';
		params.component.hideAction = params.component.hideAction === 'true';
	}

	public onMountedBuildFileIterableData(params: any) {
		const id = params.component.name.split('-')[1];
		// const collapseCardInstance = Metadata.getInstance<CollapseCard>(`collapseCard-${id}`);
		const iterableCommentsInstance = Metadata.getInstance<IterableComponentRender>('iterableComments');
		const rowData = iterableCommentsInstance.datasource.data.find((row) => row.ID === id);
		if (rowData) {
			if (rowData.ATTACHMENT.length > 0) {
				params.component.datasource.data = rowData.ATTACHMENT;
			}
		}
	}

	public downloadFileComment(params: any) {
		const fileId = params.element.name.split('-')[1];
		const commentId = params.element.name.split('-')[2];
		const fileInstance = Metadata.getInstance<IterableComponentRender>(`iterableFiles-${commentId}`);
		const fileSelected = fileInstance.datasource.data.find((file) => file.ID === fileId);
		if (fileSelected) {
			if (this.callType === 'I') {
				const downloadUri = `${this.baseUrl}/downLoadAttachment?ID=${fileSelected.ID}`;
				window.open(downloadUri);
			} else {
				const downloadUri = `${this.baseUrl}/downLoadAttachmentGEP?FILE_NAME=${fileSelected.FILE_NAME}`;
				window.open(downloadUri);
			}
		}
	}

	public downloadFileGrid(params: any) {
		if (this.callType === 'I') {
			const downloadUri = `${this.baseUrl}/downLoadAttachment?ID=${params.row.ID}`;
			window.open(downloadUri);
		} else {
			const downloadUri = `${this.baseUrl}/downLoadAttachmentGEP?FILE_NAME=${params.row.FILE_NAME}`;
			window.open(downloadUri);
		}
	}

	public async onMountedGridAttachments() {
		this.modalUploadFile = await ModalService.createFromJson('demandManagement/modal/uploadFileDemandManagementModal', true);
	}

	public onDestroyGridAttachments() {
		this.modalUploadFile.destroy();
	}

	public addClickGridAttachments() {
		this.modalUploadFile.show();
		// const grid = Metadata.getInstance<TekGrid>('gridAttachments');
		// console.log(grid);
	}

	public async saveUploadFileModal() {
		// this.saveLoadingModal = true;
        // this.noFileSelected = true;
        // const fileInput: any = Metadata.getInstance('fileInput-UploadFileDemandManagementModal');
        // const sendObject = await FileUpload.buildFileSendObject(fileInput.value[0]);
        // console.log(sendObject);
        // if (fileInput.value[0].type === 'application/pdf' && fileInput.value[0].size < 50000000) {
        //     try {
        //         const newDocSrc = await Http.post('/callAttachments/save', {
        //             dataset: [
        //                 {
        //                     UPLOAD_PRIVACY_POLICY:
        //                     [
        //                         sendObject,
        //                     ],
        //                 },
        //             ],
        //             requestType: 'DataSet',
        //         });
        //         this.docSrc = newDocSrc.data[0].pdfPath;
        //         await this.setDocSrc();
        //         this.denieDeleteButton = newDocSrc.data[0].documentDefault;
        //         this.modalPrivacyPolicy.hide();
        //     } catch (e) {
        //         LoginDialogService.showErrorBackend(e);
        //         this.noFileSelected = false;
        //     }
        //     LoginAlertService.defaultSaveSuccessAlert();
        //     this.saveLoadingModal = false;
        // } else {
        //     LoginAlertService.customErrorAlert(Messages.ERROR_PDF);
        //     this.saveLoadingModal = false;
        //     this.noFileSelected = false;
        // }
	}

	public closeUploadFileModal() {
		this.modalUploadFile.hide();
	}

	public async deleteAttachmentsGrid(params: any) {
		params.event.preventDefault();
		console.log(params.getCu);
		const sendObject = {
			dataset: params.component.selectedRows,
		};
		try {
			await Http.post('remove', sendObject);
		} catch (e) {
			DialogServiceCustom.showErrorBackend(e);
		}
	}
}
